package com.soss.system.mapper;

import com.soss.system.domain.GoodsSku;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;

/**
 * 由规格选项组合生成商品skuMapper接口
 * 
 * @author zxq
 * @date 2022-04-28
 */
public interface GoodsSkuMapper 
{
    /**
     * 查询由规格选项组合生成商品sku
     * 
     * @param id 由规格选项组合生成商品sku主键
     * @return 由规格选项组合生成商品sku
     */
    public GoodsSku selectGoodsSkuById(Long id);

    /**
     * 查询由规格选项组合生成商品sku列表
     *
     * @param goodsSku 由规格选项组合生成商品sku
     * @return 由规格选项组合生成商品sku集合
     */
    public List<GoodsSku> selectGoodsSkuList(GoodsSku goodsSku);

    /**
     * 下单时查询sku列表信息
     *
     * @param ids
     * @return
     */
    List<GoodsSku> selectSkuListForOrder(@Param("shopId") Long shopId, @Param("ids") List<Long> ids);

    /**
     * 新增由规格选项组合生成商品sku
     *
     * @param goodsSku 由规格选项组合生成商品sku
     * @return 结果
     */
    public int insertGoodsSku(GoodsSku goodsSku);

    /**
     * 修改由规格选项组合生成商品sku
     * 
     * @param goodsSku 由规格选项组合生成商品sku
     * @return 结果
     */
    public int updateGoodsSku(GoodsSku goodsSku);

    /**
     * 删除由规格选项组合生成商品sku
     * 
     * @param id 由规格选项组合生成商品sku主键
     * @return 结果
     */
    public int deleteGoodsSkuById(String id);

    /**
     * 批量删除由规格选项组合生成商品sku
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteGoodsSkuByIds(String[] ids);

    void deleteGoodsSkuByGoodsId(@Param("goodsId") String id);

    List<GoodsSku> selectSpec(String query);

    void updateSkuPrice(@Param("goodsId") long id, @Param("discountDiff") BigDecimal discountDiff, @Param("priceDiff") BigDecimal priceDiff);
}
